//+------------------------------------------------------------------+
//|                                                       XO 4TF.mq4 |
//|                                                           mladen |
//+------------------------------------------------------------------+
#property copyright ""
#property link      ""

#property indicator_separate_window
#property indicator_buffers    4
#property indicator_color1     PaleGreen
#property indicator_color2     LightCoral
#property indicator_color3     Lime
#property indicator_color4     Red
#property indicator_width1     2
#property indicator_width2     2
#property indicator_width3     2
#property indicator_width4     2
#property indicator_minimum   -4
#property indicator_maximum    4
#property indicator_level1     0
#property indicator_levelwidth 1
#property indicator_levelcolor DimGray 
#property indicator_levelstyle STYLE_DOT

//
//
//
//
//

extern string TimeFrame1  = "Current time frame";
extern string TimeFrame2  = "next1";
extern string TimeFrame3  = "next2";
extern string TimeFrame4  = "next3";
extern double KirPER1     = 4.5;
extern double KirPER2     = 4.5;
extern double KirPER3     = 4.5;
extern double KirPER4     = 4.5;
extern bool   alertsOn              = false;
extern int    alertsLevel           = 3;
extern bool   alertsMessage         = true;
extern bool   alertsSound           = false;
extern bool   alertsEmail           = false;
extern string UniqueID    = "4 time frame XO";
extern bool   SeparatorVisible = true;
extern color  SeparatorColor   = Red;
extern int    SeparatorWidth   = 2;
extern bool   SeparatorBack    = false;

//
//
//
//
//

double ExtMapBuffer1[];
double ExtMapBuffer2[];
double ExtMapBuffer3[];
double ExtMapBuffer4[];
double Hi[];
double Lo[];
double no[];
double kr[];

//
//
//
//
//

int    Kir=0;
int    tF1;
int    tF2;
int    tF3;
int    tF4;
bool   returnBars;
string indicatorFileName;
string shortName;

//------------------------------------------------------------------
//
//------------------------------------------------------------------
int init()
{
   IndicatorDigits(0);
   IndicatorBuffers(8);   
      SetIndexBuffer(0,ExtMapBuffer1); SetIndexStyle(0,DRAW_HISTOGRAM);
      SetIndexBuffer(1,ExtMapBuffer2); SetIndexStyle(1,DRAW_HISTOGRAM);
      SetIndexBuffer(2,ExtMapBuffer3); SetIndexStyle(2,DRAW_HISTOGRAM);
      SetIndexBuffer(3,ExtMapBuffer4); SetIndexStyle(3,DRAW_HISTOGRAM);
      SetIndexBuffer(4,no);
      SetIndexBuffer(5,kr);
      SetIndexBuffer(6,Hi);
      SetIndexBuffer(7,Lo);
         indicatorFileName = WindowExpertName();
         returnBars        = (TimeFrame1=="returnBars");     if (returnBars)     return(0);

   //
   //
   //
   //
   //
      
   if (TimeFrame1!="Calculate")
   {
      SetIndexEmptyValue(4,0.00);
      SetIndexEmptyValue(5,0.00);
      SetIndexEmptyValue(6,0.00);
      SetIndexEmptyValue(7,0.00);
      
      //
      //
      //
      //
      //
      
         tF1 = stringToTimeFrame(TimeFrame1);
         tF2 = stringToTimeFrame(TimeFrame2);
         tF3 = stringToTimeFrame(TimeFrame3);
         tF4 = stringToTimeFrame(TimeFrame4);
         shortName = UniqueID+" ("+timeFrameToString(tF1)+","+
                                   timeFrameToString(tF2)+","+
                                   timeFrameToString(tF3)+","+
                                   timeFrameToString(tF4)+")";
         IndicatorShortName(shortName);                                   
   }
   return(0);
}
int deinit()
{
   ObjectDelete(UniqueID);
}



//------------------------------------------------------------------
//
//------------------------------------------------------------------
double trend[][2];
#define _up 0
#define _dn 1
int start()
{
   int i,r,y,count,counted_bars=IndicatorCounted();
      if(counted_bars < 0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);
         if (returnBars) { ExtMapBuffer1[0] = limit+1; return(0); }

         if (tF1 >-1 && tF1 != Period()) limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,tF1,indicatorFileName,"returnBars",0,0)*tF1/Period()));
         if (tF2 >-1 && tF2 != Period()) limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,tF2,indicatorFileName,"returnBars",0,0)*tF2/Period()));
         if (tF3 >-1 && tF3 != Period()) limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,tF3,indicatorFileName,"returnBars",0,0)*tF3/Period()));
         if (tF4 >-1 && tF4 != Period()) limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,tF4,indicatorFileName,"returnBars",0,0)*tF4/Period()));
         
   //
   //
   //
   //
   //

   if (TimeFrame1!="Calculate")
   {
      if (ArrayRange(trend,0)!=Bars) ArrayResize(trend,Bars);
      if (SeparatorVisible)
      {
         int sepTf = MathMax(MathMax(MathMax(tF1,tF2),tF3),tF4);
         y = iBarShift(NULL,0,iTime(NULL,sepTf,iBarShift(NULL,sepTf,Time[0])));
         i = WindowFind(shortName);
            ObjectCreate(UniqueID,OBJ_VLINE,i,Time[y],-4);
               ObjectSet(UniqueID,OBJPROP_TIME1,Time[y]);
               ObjectSet(UniqueID,OBJPROP_COLOR,SeparatorColor);
               ObjectSet(UniqueID,OBJPROP_WIDTH,SeparatorWidth);
               ObjectSet(UniqueID,OBJPROP_BACK,SeparatorBack);
      }               

         //
         //
         //
         //
         //
         
         for(i=limit, r=Bars-i-1; i>=0; i--,r++)
         {
            double totalUp = 0;
            double totalDn = 0;
                if (tF1 > -1) { y = iBarShift(NULL,tF1,Time[i]); totalUp += iCustom(NULL,tF1,indicatorFileName,"Calculate","","","",KirPER1,0,y); }
                if (tF2 > -1) { y = iBarShift(NULL,tF2,Time[i]); totalUp += iCustom(NULL,tF2,indicatorFileName,"Calculate","","","",KirPER2,0,y); }
                if (tF3 > -1) { y = iBarShift(NULL,tF3,Time[i]); totalUp += iCustom(NULL,tF3,indicatorFileName,"Calculate","","","",KirPER3,0,y); }
                if (tF4 > -1) { y = iBarShift(NULL,tF4,Time[i]); totalUp += iCustom(NULL,tF4,indicatorFileName,"Calculate","","","",KirPER4,0,y); }
            ExtMapBuffer1[i] = 0.00;
            ExtMapBuffer2[i] = 0.00;
            ExtMapBuffer3[i] = 0.00;
            ExtMapBuffer4[i] = 0.00;
            
            //
            //
            //
            //
            //
          
            trend[r][_up] =   totalUp;  
            trend[r][_dn] = 4-totalUp;
            totalDn  = (totalUp-4);
               if (totalUp == 4 || totalDn== -4)
                  {               
                     ExtMapBuffer3[i] = totalUp;
                     ExtMapBuffer4[i] = totalDn;
                  }
               else
                  {
                    ExtMapBuffer1[i] = totalUp;
                    ExtMapBuffer2[i] = totalDn;
                  }                  
         }
         manageAlerts();
      return(0);         
   }

   //
   //
   //
   //
   //


   int KirPER = KirPER1;                    
   for(i = limit; i >= 0; i--)
   {         
      if (Kir<1) { Hi[i+1]=Close[i]; Lo[i+1]=Close[i]; Kir =1; }

      //
      //
      //
      //
      //
      
      double cur   = Close[i];
      Hi[i] = Hi[i+1];
      Lo[i] = Lo[i+1];
      no[i] = no[i+1];
      kr[i] = kr[i+1];

         if (cur > (Hi[i]+KirPER * Point)) 
         {
            Hi[i] = cur;
            Lo[i] = cur-KirPER*Point;
            kr[i] = 1;
            no[i] = 0;
         }
         if (cur < (Lo[i]-KirPER*Point)) 
         {
            Lo[i] = cur;
            Hi[i] = cur+KirPER*Point;
            no[i] = 1;
            kr[i] = 0;
         }

      //
      //
      //
      //
      //
      
      double valueh=kr[i];
      ExtMapBuffer1[i]=MathMin(valueh,1);
         
         if (valueh < 0) { ExtMapBuffer1[i] = 0; } 
         if (valueh > 0) { ExtMapBuffer1[i] = 1; } 

      double valuel=0-no[i];
      ExtMapBuffer2[i]=MathMax(valuel,-1);

         if (valuel > 0) { ExtMapBuffer2[i] =  0; } 
         if (valuel < 0) { ExtMapBuffer2[i] = -1; } 

   }
   return(0);
}



//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

void manageAlerts()
{
   if (alertsOn)
   {
      int whichBar = Bars-1;
      if (trend[whichBar][_up] >= alertsLevel || trend[whichBar][_dn] >= alertsLevel)
      {
         if (trend[whichBar][_up] >= alertsLevel) doAlert("up"  ,trend[whichBar][_up]);
         if (trend[whichBar][_dn] >= alertsLevel) doAlert("down",trend[whichBar][_dn]);
      }
   }
}

//
//
//
//
//

void doAlert(string doWhat, int howMany)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[0]) {
       previousAlert  = doWhat;
       previousTime   = Time[0];

       //
       //
       //
       //
       //

       message =  Symbol()+" at "+TimeToStr(TimeLocal(),TIME_SECONDS)+" "+howMany+" time frames of XO are aligned "+doWhat;
          if (alertsMessage) Alert(message);
          if (alertsEmail)   SendMail(Symbol()+" 4 time frame XO",message);
          if (alertsSound)   PlaySound("alert2.wav");
   }
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int toInt(double value) { return(value); }
int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   if (tfs=="" || tfs=="-1") return(-1);
   int max = ArraySize(iTfTable)-1, add=0;
   int nxt = (StringFind(tfs,"NEXT1")>-1); if (nxt>0) { tfs = ""+Period(); add=1; }
       nxt = (StringFind(tfs,"NEXT2")>-1); if (nxt>0) { tfs = ""+Period(); add=2; }
       nxt = (StringFind(tfs,"NEXT3")>-1); if (nxt>0) { tfs = ""+Period(); add=3; }

      //
      //
      //
      //
      //
         
      for (int i=max; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[toInt(MathMin(max,i+add))],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int char = StringGetChar(s, length);
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, length, char - 32);
         else if(char > -33 && char < 0)
                     s = StringSetChar(s, length, char + 224);
   }
   return(s);
}